
/* Version 6:
Maj: Commande progressive sur les servomoteurs */

#include <Servo.h>            // include the standard servo library
#include <Ultrasonic.h>       // include the ultrasonic librairy

// Variables pour direction
Servo leftRightServo;      // set a variable to map the servo direction
int angle;                 // set a variable to map the consigne of servo direction
int GaucheMax;             // angle a gauche Max
int DroiteMax;             // angle a droite Max

// Variables pour vitesse
Servo VitesseServo;        // set a variable to map the servo vitesse
int vitesse;               // set a variable to map the consigne of servo vitesse
int MavantMax;             // Vitesse Max Marche Avant
int MarriereMax;           // Vitesse Max Marche Arriere

// Variables pour radar
#define TRIGGER_PIN  3                          // Arduino pin tied to trigger pin on the ultrasonic sensor.
#define ECHO_PIN     2                          // Arduino pin tied to echo pin on the ultrasonic sensor.
Ultrasonic ultrasonic(TRIGGER_PIN, ECHO_PIN);   // Initialisation du radar
Servo RadarServo;                               // set a variable to map the servo
int RadarPosition;                              // set a variable to map the consigne of servo vitesse

// Variables pour serial
int val;              // Set variable de leture du port serie

/* setup the pins, servo and serial port */
void setup() {
  // Setup direction
  leftRightServo.attach(9);
  GaucheMax = 50;
  DroiteMax = 140;
  angle = 100;
  leftRightServo.write(angle);
  
  // Setup Vitesse
  VitesseServo.attach(10);
  MavantMax = 70;
  MarriereMax = 145;
  vitesse = 100;
  VitesseServo.write(vitesse);
  
  // Setup Radar
  RadarServo.attach(11);
  RadarPosition = 100;
  RadarServo.write(RadarPosition);
  
  // Setup Serial
  Serial.begin(9600);
} 
 
/* begin program */
void loop() {
  /* Calcul de la distance entre un objet */
  float Distance;
  long microsec = ultrasonic.timing();
  Distance = ultrasonic.convert(microsec, Ultrasonic::CM);
  Serial.println(Distance)
  /* Si tu Obstacle est detecte a 30cm */
  if(Distance<=30 && vitesse<=95){
      vitesse = 100;
      angle = 100;
      VitesseServo.write(vitesse);
      leftRightServo.write(angle);
      // int Decision = radar();
      Serial.println("Obstacle");
      Serial.println(Distance);
  }
  else{
   if(Serial.available()){;}    // if data is available to read
   val = Serial.read(); 
   
   if( val == '8' ){
     if(vitesse>100){
       vitesse = 100;
       VitesseServo.write(vitesse);
     }
     if (vitesse > MavantMax){
       vitesse = vitesse-1;
       VitesseServo.write(vitesse);
     }
     Serial.println("Marche avant");
     Serial.println(vitesse);
   }
   if( val == '5' ){
    Serial.println("Stop");
    vitesse = 100;
    angle = 100;
    VitesseServo.write(vitesse);
    leftRightServo.write(angle);
   }
  
  if( val == '2' ){
    if(vitesse<100){
      vitesse = 100;
      VitesseServo.write(vitesse);
    }
    if (vitesse < MarriereMax){
      vitesse = vitesse+1;
      VitesseServo.write(vitesse);
    }
    Serial.println("Marche arriere");
    Serial.println(vitesse);
  }
  if( val == '4' ){
    if(angle >100){
      angle = 100;
      leftRightServo.write(angle);
    }
    if (angle > GaucheMax){
      angle = angle-1;
      leftRightServo.write(angle);
    }
    Serial.println("Gauche");
    Serial.println(angle);
  }
  
  if( val == '6' ){
    if(angle <100){
      angle = 100;
      leftRightServo.write(angle);
    }
    if (angle < DroiteMax){
      angle = angle+1;
      leftRightServo.write(angle);
    }
    Serial.println("Droite");
    Serial.println(angle);
  }
 }
}

int radar(){
  for(RadarPosition = 180; RadarPosition > 0; RadarPosition--) {  // going right to left
    RadarServo.write(RadarPosition);
    delay(50);                      // Wait 50ms between pings (about 20 pings/sec). 29ms should be the shortest delay between pings.
    float Distance;
    long microsec = ultrasonic.timing();
    Distance = ultrasonic.convert(microsec, Ultrasonic::CM);
   //   Serial.print("X");
   // Serial.print(RadarPosition);
   // Serial.print("V");
   // Serial.println(Distance);
   }
   RadarServo.write(100);
   return 0;
}

